<?php
if ( !defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

/**
 * WPPicasa Admin Functions
 * 
 * Loads main functions used by admin menu and front-end.
 * 
 * Copyright (c) 2011, cheshirewebsolutions.com, Ian Kennerley (info@cheshirewebsolutions.com).
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/ 


/**
 *
 *  Allow redirection, even if my theme starts to send output to the browser
 *
 */	

add_action( 'init', 'cws_do_output_buffer' );
function cws_do_output_buffer() {
	ob_start();
}


/**
 *
 *  Display Messsage.
 *  If Zend Loader is not found.
 *  If Cache directory is not writable.
 *
 */	
/*
function showMessage( $preflight_check, $errormsg = false )
{
	if ( $errormsg ) {
		echo '<div id="message" class="error">';
		
		foreach($preflight_check as $message){
			echo "<p><strong>$message</strong></p>";
		}
		
		echo "</div>";
		
	}
	else {
		echo '<div id="message" class="updated fade">';
	}

	//echo "<p><strong>$message</strong></p></div>";
}    
*/
/*
function showAdminMessages( $preflight_check )
{
    // Shows as an error message. You could add a link to the right page if you wanted.
    showMessage($preflight_check, true);

    //$this->showMessage($msg, true);

	// Only show to admins
    // if ( current_user_can( 'manage_options' ) ) {
    //    $this->showMessage( "Hello admins!" );
    // }
}
*/

/**
 *
 *  Get admin URL
 *
 */	
/*
function cws_get_admin_url( $path = '' )
{
	global $wp_version;
	
	if ( version_compare( $wp_version, '3.0', '>=') ) {
		return get_admin_url( null, $path );
	}
	else {
		return get_bloginfo( 'wpurl' ) . '/wp-admin' . $path;
	}
}
*/

/**
 *
 * Get Pages into a drop-down list
 *
 */
/*
function cws_list_pages() {

	$get_page   = array();
	$pages_list = get_pages();
							
	// Loop through pages
	// Calling get_slug_by_id() and passing...
	$i = 0;
	
	foreach( $pages_list as $apage ) {
		// echo "Getting Ancestors for page_title = " . $apage->post_title   . "[ ". $apage->ID ." ]. Has parent_id of " . $apage->post_parent  .' path: ' . get_slug_by_id( $apage->ID) . "<br>";		
				
		// Start assembling the data in array...
		$path= get_slug_by_id( $apage->ID);

		$get_page[$i] = array(	'page_id' 		=> $apage->ID,
								'post_title'	=> "$apage->post_title",
								'post_path'		=> "$path",
								);
		$i++;
	}
			
	return $get_page;
}
*/

/**
 *
 * Get all the pages
 *
 */
// $pages_list = get_pages();


/**
 *
 * Get path to page. Takes into consideration parents and grandparents 
 * TODO: prefix function name with cws_
 *
 * $post_by_id, int
 * $_post_by_id_slug, string
 *
 * return string
 */
/*
function get_slug_by_id( $post_by_id, $_post_by_id_slug = '' )
{
    $post_by_id_data   = get_page( $post_by_id, OBJECT );
    $post_by_id_parent = $post_by_id_data->post_parent;
    $post_by_id_slug   = $post_by_id_data->post_name;

    // If there are no more parents
    // return path/to/page
    if ( 0 == $post_by_id_parent ) {
    	      	       
      $_path .= $post_by_id_slug . '/'. $_post_by_id_slug ;	       	       
      
      return "$_path";	      
    } 
    else {
       	return get_slug_by_id( $post_by_id_parent, $post_by_id_slug );
    }		
}
*/
	
/* -----------------------------------------------------------------------
 *	Setup custom URL parameters for use when displaying gallery images	
/*------------------------------------------------------------------------*/
/*
function cws_gpp_add_query_var( $qvars ) {
	$qvars[] = 'album_id';
	return $qvars;
}	
*/

// Add a new URL parameter
// add_filter( 'query_vars', 'cws_gpp_add_query_var' );


// Retrieve and display the URL parameter
function cws_gpp_output_album_id() {
	global $wp_query;
	
	if( isset( $wp_query->query_vars['album_id'] ) ) {
		return $wp_query->query_vars['album_id'];
	}
}

function custom_query_vars_filter($vars) {
	$vars[] = 'cws_page';
	$vars[] .= 'cws_album';
//	$vars[] .= 'cws_album_title';
    $vars[] .= 'cws_debug'; // add for simple way to enable debugging via address bar
  return $vars;
}
add_filter( 'query_vars', 'custom_query_vars_filter' );

//

/**
 * Checks for cws_gpp_images_in_album shortcode and flags the post with post meta.
 * @param integer $post_id
 * @return integer
 */
/*
function save_result_page_postmeta( $post_id )
{
    // Make sure this isn't an autosave.
    if( !defined( 'DOING_AUTOSAVE') || !DOING_AUTOSAVE ){
        // Get Post Content
        $content = get_post_field( 'post_content', $post_id );
        // Check for shortcode
        if( has_shortcode( $content, 'cws_gpp_images_in_album' ) ) {
            // Update (or it will insert) the 'has_calender' post meta.
            update_post_meta( $post_id, 'cws_gpp_images_in_album', '1' );
        }
        else {
            // Delete the has calender post meta if it exists.
            delete_post_meta( $post_id, 'cws_gpp_images_in_album' );
            echo "DELETE THE META";
        }
    }
    return $post_id;
}
add_action( 'save_post', 'save_result_page_postmeta' );
*/

/**
 * Get all posts and their permalinks that have album results shortcode.
 * @global wpdb $wpdb
 */
/*function get_result_posts_links()
{
    global $wpdb;

    $rows = $wpdb->get_results($wpdb->prepare(
            "SELECT post_id FROM $wpdb->postmeta WHERE meta_key = %s",
            'cws_gpp_images_in_album'
    ));
    if( !empty( $rows ) ) {
        // Let's include the post permalinks with each row.
        foreach( $rows as $row ) {
            $row->post_permalink = get_permalink( $row->post_id );
            $row->title = get_the_title( $row->post_id );
        }
    }
    return $rows;
}
*/

/**
 * Checks for cws_gpp_thumbnail_grid shortcode and flags the post with post meta. So we can inject CSS on pages where the shortcode is used.
 * to reduce unnecessary http requests
 * @param integer $post_id
 * @return integer
 */
/*
function save_result_postmeta_grid( $post_id )
{
    // Make sure this isn't an autosave.
    if( !defined( 'DOING_AUTOSAVE') || !DOING_AUTOSAVE ){
        // Get Post Content
        $content = get_post_field( 'post_content', $post_id );
        // Check for shortcode
        if( has_shortcode( $content, 'cws_gpp_thumbnail_grid' ) ) {
            // Update (or it will insert) the 'has_calender' post meta.
            update_post_meta( $post_id, 'cws_gpp_thumbnail_grid', '1' );
        }
        else {
            // Delete the has calender post meta if it exists.
            delete_post_meta( $post_id, 'cws_gpp_thumbnail_grid' );
        }
    }
    return $post_id;
}
add_action( 'save_post', 'save_result_postmeta_grid' );
*/

/**
 * Get all posts and check their post meta that have cws_gpp_thumbnail_grid shortcode.
 * Register and enque the styles for this shortcode
 * @global wpdb $wpdb
 */
/*
function get_result_posts_links_grid ()
{
    global $wpdb;

    $rows = $wpdb->get_results($wpdb->prepare(
            "SELECT post_id FROM $wpdb->postmeta WHERE meta_key = %s",
            'cws_gpp_thumbnail_grid'
    ));
    if( !empty( $rows ) ) {
				wp_register_style( 'cws_gpp_thumbnail_grid_css', plugins_url( 'public/css/default.css',__FILE__ ) , '', 1 );
				wp_register_style( 'cws_gpp_thumbnail_grid_css2', plugins_url( 'public/css/component.css',__FILE__ ) , '', 1 );

				if ( function_exists( 'wp_enqueue_style' ) ) {
					wp_enqueue_style( 'cws_gpp_thumbnail_grid_css' );
					wp_enqueue_style( 'cws_gpp_thumbnail_grid_css2' );
				}    	
    }
}
*/


/**
 * Checks for cws_gpp_slick_carousel shortcode and flags the post with post meta. So we can inject CSS on pages where the shortcode is used.
 * to reduce unnecessary http requests
 * @param integer $post_id
 * @return integer
 */
/*
function save_result_postmeta_sc( $post_id )
{
    // Make sure this isn't an autosave.
    if( !defined( 'DOING_AUTOSAVE') || !DOING_AUTOSAVE ){
        // Get Post Content
        $content = get_post_field( 'post_content', $post_id );
        // Check for shortcode
        if( has_shortcode( $content, 'cws_gpp_slick_carousel' ) ) {
            // Update (or it will insert) the 'has_calender' post meta.
            update_post_meta( $post_id, 'cws_gpp_slick_carousel', '1' );
        }
        else {
            // Delete the has calender post meta if it exists.
            delete_post_meta( $post_id, 'cws_gpp_slick_carousel' );
        }
    }
    return $post_id;
}
add_action( 'save_post', 'save_result_postmeta_sc' );
*/

/**
 * Get all posts and check their post meta that have cws_gpp_slick_carousel shortcode.
 * Register and enque the styles for this shortcode
 * @global wpdb $wpdb
 */
/*
function get_result_posts_links_sc ()
{
    global $wpdb;

    $rows = $wpdb->get_results($wpdb->prepare(
            "SELECT post_id FROM $wpdb->postmeta WHERE meta_key = %s",
            'cws_gpp_slick_carousel'
    ));
    if( !empty( $rows ) ) {
                wp_register_style( 'cws_gpp_cws_gpp_slick_carousel_css', plugins_url( 'public/css/slick/slick.css',__FILE__ ) , '', 1 );
                wp_register_style( 'cws_gpp_cws_gpp_slick_carousel_css_theme', plugins_url( 'public/css/slick/slick-theme.css',__FILE__ ) , '', 1 );

                wp_register_style( 'cws_gpp_cws_gpp_slick_lb_css', plugins_url( 'public/css/slick-lightbox/slick-lightbox.css',__FILE__ ) , '', 1 );

                if ( function_exists( 'wp_enqueue_style' ) ) {
                    wp_enqueue_style( 'cws_gpp_cws_gpp_slick_carousel_css' );
                    wp_enqueue_style( 'cws_gpp_cws_gpp_slick_carousel_css_theme' );
                    wp_enqueue_style( 'cws_gpp_cws_gpp_slick_lb_css' );
                }       
    }
}
*/

