<?php
/**
 * Copyright (c) 2011, cheshirewebsolutions.com, Ian Kennerley (info@cheshirewebsolutions.com).
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
function cws_gpp_shortcode_albums( $atts ) {
											
    $plugin = new CWS_Google_Picasa_Pro();
    
    // should this be in CWS_Google_Picasa_Pro_Public? with it being in a frontend shortcode
    $plugin_admin = new CWS_Google_Picasa_Pro_Admin( $plugin->get_plugin_name(), $plugin->get_version() );

    // If authenticated get list of albums
    if( $plugin_admin->isAuthenticated() == true  ) {

        // Grab options stored in db
        $options = get_option( 'cws_gpp_options' );

        // Extract the options from db and overwrite with any set in the shortcode
        extract( shortcode_atts( array(
            'thumb_size'   => $options['album_thumb_size'], 
            'show_title'         => $options['show_album_title'],
            'show_details' => $options['show_album_details'],
            'num_results'  => $options['num_album_results'],
            'visibility'         => $options['private_albums'],
            'results_page'       => $options['results_page'],
            'hide_albums'        => $options['hide_albums'],
            'theme'              => $options['theme'],
        ), $atts ) );

        // Map albums names to hide to array and trim white space
        $hide_albums = array_map( 'trim', explode( ',', $hide_albums ) );

        // TODO: cast other vars to int if required
        $thumb_size = (int) $thumb_size;

        if ( $show_title === 'false' ) $show_title = false; // just to be sure...
        if ( $show_title === 'true' ) $show_title = true; // just to be sure...
        if ( $show_title === '0' ) $show_title = false; // just to be sure...
        if ( $show_title === '1' ) $show_title = true; // just to be sure...
        $show_title = ( bool ) $show_title;  

        if ( $show_details === 'false' ) $show_details = false; // just to be sure...
        if ( $show_details === 'true' ) $show_details = true; // just to be sure...
        if ( $show_details === '0' ) $show_details = false; // just to be sure...
        if ( $show_details === '1' ) $show_details = true; // just to be sure...
        $show_details = ( bool ) $show_details;  
        
        // Grab page from url
        $cws_page = get_query_var('cws_page');

        // Grab the access token
        $AccessToken = get_option( 'cws_gpp_access_token' );

        // To remove pagination from carousel page
        if( $theme == 'carousel') { $num_results = 0; }

        // Get Albums
        $response = $plugin_admin->getAlbumList( $AccessToken, $thumb_size, $show_title, $cws_page, $num_results, $visibility );             

        #----------------------------------------------------------------------------
        # Parse the XML response into array $vals
        #----------------------------------------------------------------------------
        $p = xml_parser_create();
        xml_parse_into_struct( $p, $response, $vals, $index );
        xml_parser_free( $p );

        #----------------------------------------------------------------------------
        # Iterate over the array and extract the info we want
        #----------------------------------------------------------------------------

        // Get the posts that have the results shortcode on them [cws_gpp_images_in_album]
        // only use the first one
        // TODO: improve this
        // $results_posts = get_result_posts_links();

        // Decide which layout to use to display the albums
        switch( $theme ) {
            #----------------------------------------------------------------------------
            # Grid Layout
            #----------------------------------------------------------------------------
            case "grid":

                // Include Masonry
                wp_enqueue_script( 'cws_gpp_masonry', plugin_dir_url( __FILE__ )  . '../public/js/masonry.pkgd.min.js', array( 'jquery' ), false, true ); 
                wp_enqueue_script( 'cws_gpp_imagesLoaded', plugin_dir_url( __FILE__ )  . '../public/js/imagesloaded.pkgd.min.js', array( 'jquery' ), false, true ); 
                    
                // Initialize Masonry
                wp_enqueue_script( 'cws_gpp_init_masonry', plugin_dir_url( __FILE__ )  . '../public/js/init_masonry.js', array( 'cws_gpp_masonry' ), false , true );            
                include 'partials/grid.php';
                break;

            #----------------------------------------------------------------------------
            # List Layout
            #----------------------------------------------------------------------------
            case "list":
                include 'partials/list.php';            
                break;

            #----------------------------------------------------------------------------
            # Carousel Layout
            #----------------------------------------------------------------------------
            case "carousel":

                // Include Slick
                wp_enqueue_script( 'cws_gpp_slick', plugin_dir_url( __FILE__ )  . '../public/js/slick/slick.min.js', array( 'jquery' ), false, true ); 
                   
                // Initialize Slick
                wp_enqueue_script( 'cws_gpp_init_slick', plugin_dir_url( __FILE__ )  . '../public/js/slick/init_slick.js', array( 'cws_gpp_slick' ), false , true );
                
                include 'partials/carousel.php';
                break;

            #----------------------------------------------------------------------------
            # Default Layout - Grid
            #----------------------------------------------------------------------------
            default:
                include 'partials/grid.php';            
        }

        #----------------------------------------------------------------------------
        # Show output for pagination
        #----------------------------------------------------------------------------
        $num_pages  = ceil( $total_num_albums / $num_results );

        // If someone has done some url hacking reset page to something sensible
        if ( isset($cws_page) && $cws_page > $num_pages ) { $cws_page = $num_pages; }

        // total results, num to show per page, current page
        $strOutput .= $plugin_admin->get_pagination( $total_num_albums, $num_results, $cws_page );

        return $strOutput;

    } // end if authenticated check 
    //// http://code.tutsplus.com/articles/create-wordpress-plugins-with-oop-techniques--net-20153
    
}