<?php
/**
 * Copyright (c) 2011, cheshirewebsolutions.com, Ian Kennerley (info@cheshirewebsolutions.com).
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
function cws_gpp_shortcode_images_in_album( $atts ) {
																						   
    $plugin = new CWS_Google_Picasa_Pro();
    
    // should this be in CWS_Google_Picasa_Pro_Public? with it being in a frontend shortcode
    $plugin_admin = new CWS_Google_Picasa_Pro_Admin( $plugin->get_plugin_name(), $plugin->get_version() );

    // If authenticated get list of albums
    if( $plugin_admin->isAuthenticated() == true  ) {
        
        $options = get_option( 'cws_gpp_options' );
        $album_thumb_size = $options['album_thumb_size'];

        extract( shortcode_atts( array(
            'thumb_size'        => $options['thumb_size'], 
            'show_title'        => $options['show_image_title'],
            'show_details'=> $options['show_image_details'],
            'num_results' => $options['num_image_results'],
            'theme'             => $options['theme'],           
        ), $atts ) );


        if ( $show_title === 'false' ) $show_title = false; // just to be sure...
        if ( $show_title === 'true' ) $show_title = true; // just to be sure...
        if ( $show_title === '0' ) $show_title = false; // just to be sure...
        if ( $show_title === '1' ) $show_title = true; // just to be sure...
        $show_title = ( bool ) $show_title;          

        if ( $show_details === 'false' ) $show_details = false; // just to be sure...
        if ( $show_details === 'true' ) $show_details = true; // just to be sure...
        if ( $show_details === '0' ) $show_details = false; // just to be sure...
        if ( $show_details === '1' ) $show_details = true; // just to be sure...
        $show_details = ( bool ) $show_details;       
                
        // Grab album id
		$cws_album = get_query_var( 'cws_album' );
        
        // Grab page from url
        $cws_page = get_query_var( 'cws_page' );        
        
        // Grab the access token
        $AccessToken = get_option( 'cws_gpp_access_token' );

        // no pagintaion required if results are carousel
        if( $theme == "carousel" ) { $num_results = 0; }

        // Get images in a specific album
        $response = $plugin_admin->getAlbumImages( $AccessToken, $thumb_size, $show_title, $cws_page, $num_results, $cws_album );     
        

        #----------------------------------------------------------------------------
        # Parse the XML response into array $vals
        #----------------------------------------------------------------------------
        $p = xml_parser_create();
        xml_parse_into_struct( $p, $response, $vals, $index );
        xml_parser_free( $p );


        // Decide which layout to use to display the albums
        switch( $theme ) {

            #----------------------------------------------------------------------------
            # Grid Layout
            #----------------------------------------------------------------------------
            case "grid":

                include 'partials/results_grid.php';

                wp_enqueue_script( 'cws_gpp_lightbox', plugin_dir_url( __FILE__ )  . '../public/js/lightbox/lightbox.js', array( 'jquery' ), false, true );                 
                    
                // Initialize Lightbox
                wp_enqueue_script( 'cws_gpp_init_lightbox', plugin_dir_url( __FILE__ )  . '../public/js/lightbox/init_lightbox.js', array( 'cws_gpp_lightbox' ), false , true );

                // Include Masonry
                wp_enqueue_script( 'cws_gpp_masonry', plugin_dir_url( __FILE__ )  . '../public/js/masonry.pkgd.min.js', array( 'jquery' ), false, true ); 
                wp_enqueue_script( 'cws_gpp_imagesLoaded', plugin_dir_url( __FILE__ )  . '../public/js/imagesloaded.pkgd.min.js', array( 'jquery' ), false, true ); 
                    
                // Initialize Masonry
                wp_enqueue_script( 'cws_gpp_init_masonry', plugin_dir_url( __FILE__ )  . '../public/js/init_masonry.js', array( 'cws_gpp_masonry' ), false , true );

                break;

            #----------------------------------------------------------------------------
            # List Layout
            #----------------------------------------------------------------------------   
            case "list":
             
                include 'partials/results_list.php';   

                wp_enqueue_script( 'cws_gpp_lightbox', plugin_dir_url( __FILE__ )  . '../public/js/lightbox/lightbox.js', array( 'jquery' ), false, true );                 
                    
                // Initialize Lightbox
                wp_enqueue_script( 'cws_gpp_init_lightbox', plugin_dir_url( __FILE__ )  . '../public/js/lightbox/init_lightbox.js', array( 'cws_gpp_lightbox' ), false , true );
                break;

            #----------------------------------------------------------------------------
            # Carousel Layout
            #----------------------------------------------------------------------------   
            case "carousel":

                include 'partials/results_carousel.php';

                // Include Slick
                wp_enqueue_script( 'cws_gpp_slick', plugin_dir_url( __FILE__ )  . '../public/js/slick/slick.min.js', array( 'jquery' ), false, true ); 

                // Include Slick Lightbox
                // TODO: make this optional
                wp_enqueue_script( 'cws_gpp_slick_lb', plugin_dir_url( __FILE__ )  . '../public/js/slick-lightbox/slick-lightbox.js', array( 'cws_gpp_slick' ), false, true ); 
                    
                // Initialize Slick
                wp_enqueue_script( 'cws_gpp_init_slick', plugin_dir_url( __FILE__ )  . '../public/js/slick/init_slick.js', array( 'cws_gpp_slick_lb' ), false , true );

                // Initialize Slick Lightbox
                //wp_enqueue_script( 'cws_gpp_init_slick_lb', plugin_dir_url( __FILE__ )  . '../public/js/slick-lightbox/init_lightbox.js', array( 'cws_gpp_slick_lb' ), false , true );                    
                break;

/*
            case "expander";

                // Add Javascript
                // Include Modernizr
                wp_enqueue_script( 'cws_gpp_modernizr', plugin_dir_url( __FILE__ )  . '../public/js/modernizr.custom.js', array(), false, false );  

                // Include Grid
                wp_enqueue_script( 'cws_gpp_grid', plugin_dir_url( __FILE__ )  . '../public/js/grid.js', array( 'cws_gpp_modernizr' ), false , true );
                
                // Initialize Grid
                wp_enqueue_script( 'cws_gpp_init_grid', plugin_dir_url( __FILE__ )  . '../public/js/init_grid.js', array( 'cws_gpp_grid' ), false , true );
            
                include 'partials/results_expander.php';
                break;
*/
            #----------------------------------------------------------------------------
            # Default Layout - Grid
            #----------------------------------------------------------------------------   
            default:
                include 'partials/results_grid.php';
                echo "Include partials/results_grid.php case default. ";

        }

        #----------------------------------------------------------------------------
        # Show output for pagination
        #----------------------------------------------------------------------------
        $num_pages  = ceil( $num_photos / $num_results );

        // If someone has done some url hacking reset page to something sensible
        if ( isset($cws_page) && $cws_page > $num_pages ) { $cws_page = $num_pages; }

        // total results, num to show per page, current page, album id optional
        $strOutput .= $plugin_admin->get_pagination( $num_photos, $num_results, $cws_page, $cws_album );

        return $strOutput;

    }   // end if authenticated check 
    //// http://code.tutsplus.com/articles/create-wordpress-plugins-with-oop-techniques--net-20153
    
}