<?php
/**
 * Copyright (c) 2011, cheshirewebsolutions.com, Ian Kennerley (info@cheshirewebsolutions.com).
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
function cws_gpp_shortcode_thumbnail_grid( $atts ) {
	
    // Add CSS
    get_result_posts_links_grid();
    
    // Add Javascript
    // Include Modernizr
    wp_enqueue_script( 'cws_gpp_modernizr', plugin_dir_url( __FILE__ )  . '../public/js/modernizr.custom.js', array(), false, false );  

    // Include Grid
    wp_enqueue_script( 'cws_gpp_grid', plugin_dir_url( __FILE__ )  . '../public/js/grid.js', array( 'cws_gpp_modernizr' ), false , true );
    
    // Initialize Grid
    wp_enqueue_script( 'cws_gpp_init_grid', plugin_dir_url( __FILE__ )  . '../public/js/init_grid.js', array( 'cws_gpp_grid' ), false , true );
             

    $plugin = new CWS_Google_Picasa_Pro();
    
    // should this be in CWS_Google_Picasa_Pro_Public? with it being in a frontend shortcode
    $plugin_admin = new CWS_Google_Picasa_Pro_Admin( $plugin->get_plugin_name(), $plugin->get_version() );

    // If authenticated get list of albums
    if( $plugin_admin->isAuthenticated() == true  ) {
        
        $options = get_option( 'cws_gpp_options' );
        $album_thumb_size = $options['album_thumb_size'];


        extract( shortcode_atts( array(
            'thumb_size'  => $options['thumb_size'], 
            'show_album_title'  => $options['show_album_title'],
            'show_image_title'  => $options['show_image_title'],
            'show_image_details'  => $options['show_image_details'],
            'num_image_results' => $options['num_image_results'],
        ), $atts ) );


        if ( $atts['show_album_title'] === 'false' ) $show_album_title = false; // just to be sure...
        if ( $atts['show_album_title'] === 'true' ) $show_album_title = true; // just to be sure...
        if ( $atts['show_album_title'] === '0' ) $show_album_title = false; // just to be sure...
        if ( $atts['show_album_title'] === '1' ) $show_album_title = true; // just to be sure...
        $show_album_ttl = (bool) $show_album_title;       

        if ( $atts['show_image_details'] === 'false' ) $show_image_details = false; // just to be sure...
        if ( $atts['show_image_details'] === 'true' ) $show_image_details = true; // just to be sure...
        if ( $atts['show_image_details'] === '0' ) $show_image_details = false; // just to be sure...
        if ( $atts['show_image_details'] === '1' ) $show_image_details = true; // just to be sure...
        $show_image_details = (bool) $show_image_details;        
                
        // var_dump($show_image_details);

        // Grab album id
		$cws_album = get_query_var( 'cws_album' );
        
        // Grab page from url
        $cws_page = get_query_var('cws_page');        
        
        // Grab the access token
        $AccessToken = get_option( 'cws_gpp_access_token' );

        // Get images in a specific album
        $response = $plugin_admin->getAlbumImages( $AccessToken, $thumb_size, $show_album_title, $cws_page, $num_image_results, $cws_album );     
        
        // var_dump( $response );

        #----------------------------------------------------------------------------
        # Parse the XML response into array $vals
        #----------------------------------------------------------------------------
        $p = xml_parser_create();
        xml_parse_into_struct( $p, $response, $vals, $index );
        xml_parser_free( $p );

// echo '<pre>';
// print_r($vals);
// echo '</pre>';


		#----------------------------------------------------------------------------
		# Iterate over the $vals
		#----------------------------------------------------------------------------

		unset($thumb);
		unset($title);
		unset($href);
		unset($path);
		unset($url);
		$image_count=0;


            echo "<div class='container'>\n";
            echo "<div class='main'>\n";
            // echo "<ul id='og-grid' class='og-grid'>\n";

		foreach ( $vals as $val ) {


                if ($OPEN != 1) {

                    if ($val["tag"] == "TITLE") {

                        if ($val["type"] == "complete")  {
							$album_title = $val["value"] ;
                            $OPEN = 1;
                        }
                    }

                } else {

        	switch ( $val["tag"] ) {

                case "MEDIA:THUMBNAIL":
                        $thumb = trim( $val["attributes"]["URL"] . "\n" );
                        break;

                case "MEDIA:TITLE":
                        $title = trim( $val["value"] );
                        break;

                case "MEDIA:DESCRIPTION":
                        if ( $val["attributes"]["REL"] == "alternate" ) {
                            $href = trim( $val["attributes"]["HREF"] );
                        }
                        break;

                case "MEDIA:CONTENT":
                        $href = $val["attributes"]["URL"];
                        $imght = $val["attributes"]["HEIGHT"];
                        $imgwd = $val["attributes"]["WIDTH"];
                        break;

                case "SUMMARY":
                        $text = $val["value"];
                        break;

                case "GPHOTO:NUMPHOTOS":
                        $numphotos = $val["value"]; // num photos in a particular album
                        //echo "<h1>Total Photos in this album = $numphotos</h1>";
                        break;

                case "GPHOTO:ID":
                        if ( !isset($STOP_FLAG) ) {
                            $gphotoid = trim( $val["value"] );
                        }
                        break;
        }

    }

        #----------------------------------------------------------------------------
        # Once we have all the pieces of info we want, dump the output
        #----------------------------------------------------------------------------
        if ( isset( $thumb ) && isset( $title ) && isset( $href ) && isset( $gphotoid ) ) {

                // TODO rename this stop flag bollocks
                if ( $STOP_FLAG != 1 ) {
                        // $ALBUMS_PER_ROW_LESS_ONE = $ALBUMS_PER_ROW - 1;

                    if ( $show_album_title ) {
                        echo "<div id='album_title'><h2>$album_title</h2></div>\n";                        
                    }
                    echo "<ul id='og-grid' class='og-grid'>\n";

                    $STOP_FLAG=1;
                }
                $count++;

                echo "<li>\n";
                    echo "<a href='#' data-largesrc='$href' data-title='$title' data-description='$text'><img src='$thumb' alt='image_from_picasa'></img></a>\n";
                echo "</li>\n";


                #----------------------------------
                # Reset the variables
                #----------------------------------
                
                // TODO do I need all these?
                unset( $thumb, $title, $href, $path, $url, $text ); 
        }


}


                    echo "</ul>\n";
                echo "</div>";
                echo "</div>";


        #----------------------------------------------------------------------------
        # Show output for pagination
        #----------------------------------------------------------------------------
        //num pages needed = number of photos returned / num images per page as per settings
        $num_pages  = ceil( $numphotos / $num_image_results );

        // echo "cws page $cws_page<br>";
        // echo "num pages $num_pages<br>";

        // If someone has done some url hacking reset page to something sensible
        if ( isset($cws_page) && $cws_page > $num_pages ) {
            $cws_page = $num_pages;
        }

        // total results, num to show per page, current page, album id optional
        echo $plugin_admin->get_pagination( $numphotos, $num_image_results, $cws_page, $cws_album );
        //

    }   // end if authenticated check 
    //// http://code.tutsplus.com/articles/create-wordpress-plugins-with-oop-techniques--net-20153
    
}